diff --git a/libdwfl/elf-from-memory.c b/libdwfl/elf-from-memory.c
index 47e743d..120f16e 100644
--- a/libdwfl/elf-from-memory.c
+++ b/libdwfl/elf-from-memory.c
@@ -31,6 +31,7 @@
 #undef _
 
 #include "libdwflP.h"
+#include "nested_func.h"
 
 #include <gelf.h>
 #include <sys/types.h>
@@ -69,12 +70,12 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
 {
   /* We might have to reserve some memory for the phdrs.  Set to NULL
      here so we can always safely free it.  */
-  void *phdrsp = NULL;
+  __BLOCK void *phdrsp = NULL;
 
   /* First read in the file header and check its sanity.  */
 
   const size_t initial_bufsize = 256;
-  unsigned char *buffer = malloc (initial_bufsize);
+  __BLOCK unsigned char *buffer = malloc (initial_bufsize);
   if (unlikely (buffer == NULL))
     {
     no_memory:
@@ -82,7 +83,7 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
       return NULL;
     }
 
-  ssize_t nread = (*read_memory) (arg, buffer, ehdr_vma,
+  __BLOCK ssize_t nread = (*read_memory) (arg, buffer, ehdr_vma,
 				  sizeof (Elf32_Ehdr), initial_bufsize);
   if (nread <= 0)
     {
@@ -104,18 +105,18 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
 
   /* Extract the information we need from the file header.  */
 
-  union
+  __BLOCK union
   {
     Elf32_Ehdr e32;
     Elf64_Ehdr e64;
   } ehdr;
-  Elf_Data xlatefrom =
+  __BLOCK Elf_Data xlatefrom =
     {
       .d_type = ELF_T_EHDR,
       .d_buf = buffer,
       .d_version = EV_CURRENT,
     };
-  Elf_Data xlateto =
+  __BLOCK Elf_Data xlateto =
     {
       .d_type = ELF_T_EHDR,
       .d_buf = &ehdr,
@@ -123,10 +124,10 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
       .d_version = EV_CURRENT,
     };
 
-  GElf_Off phoff;
-  uint_fast16_t phnum;
-  uint_fast16_t phentsize;
-  GElf_Off shdrs_end;
+  __BLOCK GElf_Off phoff;
+  __BLOCK uint_fast16_t phnum;
+  __BLOCK uint_fast16_t phentsize;
+  __BLOCK GElf_Off shdrs_end;
 
   switch (buffer[EI_CLASS])
     {
@@ -198,8 +199,8 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
   const int phdrsp_bytes =
       phnum * MAX (sizeof (Elf32_Phdr), sizeof (Elf64_Phdr));
   phdrsp = malloc (phdrsp_bytes);
-  Elf32_Phdr *p32 = phdrsp;
-  Elf64_Phdr *p64 = phdrsp;
+  __BLOCK Elf32_Phdr *p32 = phdrsp;
+  __BLOCK Elf64_Phdr *p64 = phdrsp;
   if (unlikely (phdrsp == NULL))
     {
       free (buffer);
@@ -210,49 +211,52 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
   xlateto.d_size = phdrsp_bytes;
 
   /* Scan for PT_LOAD segments to find the total size of the file image.  */
-  size_t contents_size = 0;
-  GElf_Off segments_end = 0;
-  GElf_Off segments_end_mem = 0;
-  GElf_Addr loadbase = ehdr_vma;
-  bool found_base = false;
-  switch (ehdr.e32.e_ident[EI_CLASS])
+  __BLOCK size_t contents_size = 0;
+  __BLOCK GElf_Off segments_end = 0;
+  __BLOCK GElf_Off segments_end_mem = 0;
+  __BLOCK GElf_Addr loadbase = ehdr_vma;
+  __BLOCK bool found_base = false;
+
+  /* Sanity checks segments and calculates segment_end,
+   segments_end, segments_end_mem and loadbase (if not
+   found_base yet).  Returns true if sanity checking failed,
+   false otherwise.  */
+  INLINE_NESTED_FUNC (bool, handle_segment1,
+                      (GElf_Addr, GElf_Off, GElf_Xword, GElf_Xword),
+                      (GElf_Addr vaddr, GElf_Off offset,
+                       GElf_Xword filesz, GElf_Xword memsz))
     {
-      /* Sanity checks segments and calculates segment_end,
-	 segments_end, segments_end_mem and loadbase (if not
-	 found_base yet).  Returns true if sanity checking failed,
-	 false otherwise.  */
-      inline bool handle_segment (GElf_Addr vaddr, GElf_Off offset,
-				  GElf_Xword filesz, GElf_Xword memsz)
-	{
-	  /* Sanity check the segment load aligns with the pagesize.  */
-	  if (((vaddr - offset) & (pagesize - 1)) != 0)
-	    return true;
+      /* Sanity check the segment load aligns with the pagesize.  */
+      if (((vaddr - offset) & (pagesize - 1)) != 0)
+        return true;
 
-	  GElf_Off segment_end = ((offset + filesz + pagesize - 1)
-				  & -pagesize);
+      GElf_Off segment_end = ((offset + filesz + pagesize - 1)
+                             & -pagesize);
 
-	  if (segment_end > (GElf_Off) contents_size)
-	    contents_size = segment_end;
+      if (segment_end > (GElf_Off) contents_size)
+        contents_size = segment_end;
 
-	  if (!found_base && (offset & -pagesize) == 0)
-	    {
-	      loadbase = ehdr_vma - (vaddr & -pagesize);
-	      found_base = true;
-	    }
+      if (!found_base && (offset & -pagesize) == 0)
+        {
+          loadbase = ehdr_vma - (vaddr & -pagesize);
+          found_base = true;
+        }
 
-	  segments_end = offset + filesz;
-	  segments_end_mem = offset + memsz;
-	  return false;
-	}
+      segments_end = offset + filesz;
+      segments_end_mem = offset + memsz;
+      return false;
+    };
 
+  switch (ehdr.e32.e_ident[EI_CLASS])
+    {
     case ELFCLASS32:
       if (elf32_xlatetom (&xlateto, &xlatefrom,
 			  ehdr.e32.e_ident[EI_DATA]) == NULL)
 	goto libelf_error;
       for (uint_fast16_t i = 0; i < phnum; ++i)
 	if (p32[i].p_type == PT_LOAD)
-	  if (handle_segment (p32[i].p_vaddr, p32[i].p_offset,
-			      p32[i].p_filesz, p32[i].p_memsz))
+	  if (handle_segment1 (p32[i].p_vaddr, p32[i].p_offset,
+			       p32[i].p_filesz, p32[i].p_memsz))
 	    goto bad_elf;
       break;
 
@@ -262,8 +266,8 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
 	goto libelf_error;
       for (uint_fast16_t i = 0; i < phnum; ++i)
 	if (p64[i].p_type == PT_LOAD)
-	  if (handle_segment (p64[i].p_vaddr, p64[i].p_offset,
-			      p64[i].p_filesz, p64[i].p_memsz))
+	  if (handle_segment1 (p64[i].p_vaddr, p64[i].p_offset,
+			       p64[i].p_filesz, p64[i].p_memsz))
 	    goto bad_elf;
       break;
 
@@ -297,28 +301,29 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
       goto no_memory;
     }
 
-  switch (ehdr.e32.e_ident[EI_CLASS])
+  /* Reads the given segment.  Returns true if reading fails,
+     false otherwise.  */
+  INLINE_NESTED_FUNC (bool, handle_segment2,
+                      (GElf_Addr, GElf_Off, GElf_Xword),
+                      (GElf_Addr vaddr, GElf_Off offset, GElf_Xword filesz))
     {
-      /* Reads the given segment.  Returns true if reading fails,
-	 false otherwise.  */
-      inline bool handle_segment (GElf_Addr vaddr, GElf_Off offset,
-				  GElf_Xword filesz)
-	{
-	  GElf_Off start = offset & -pagesize;
-	  GElf_Off end = (offset + filesz + pagesize - 1) & -pagesize;
-	  if (end > (GElf_Off) contents_size)
-	    end = contents_size;
-	  nread = (*read_memory) (arg, buffer + start,
-				  (loadbase + vaddr) & -pagesize,
-				  end - start, end - start);
-	  return nread <= 0;
-	}
+      GElf_Off start = offset & -pagesize;
+      GElf_Off end = (offset + filesz + pagesize - 1) & -pagesize;
+      if (end > (GElf_Off) contents_size)
+        end = contents_size;
+      nread = (*read_memory) (arg, buffer + start,
+                              (loadbase + vaddr) & -pagesize,
+                               end - start, end - start);
+      return nread <= 0;
+    };
 
+  switch (ehdr.e32.e_ident[EI_CLASS])
+    {
     case ELFCLASS32:
       for (uint_fast16_t i = 0; i < phnum; ++i)
 	if (p32[i].p_type == PT_LOAD)
-	  if (handle_segment (p32[i].p_vaddr, p32[i].p_offset,
-			      p32[i].p_filesz))
+	  if (handle_segment2 (p32[i].p_vaddr, p32[i].p_offset,
+			       p32[i].p_filesz))
 	    goto read_error;
 
       /* If the segments visible in memory didn't include the section
@@ -344,8 +349,8 @@ elf_from_remote_memory (GElf_Addr ehdr_vma,
     case ELFCLASS64:
       for (uint_fast16_t i = 0; i < phnum; ++i)
 	if (p64[i].p_type == PT_LOAD)
-	  if (handle_segment (p64[i].p_vaddr, p64[i].p_offset,
-			      p64[i].p_filesz))
+	  if (handle_segment2 (p64[i].p_vaddr, p64[i].p_offset,
+			       p64[i].p_filesz))
 	    goto read_error;
 
       /* If the segments visible in memory didn't include the section
diff --git a/libdwfl/frame_unwind.c b/libdwfl/frame_unwind.c
index bd100b8..51c1f90 100644
--- a/libdwfl/frame_unwind.c
+++ b/libdwfl/frame_unwind.c
@@ -34,6 +34,7 @@
 #include <stdlib.h>
 #include "libdwflP.h"
 #include "../libdw/dwarf.h"
+#include "nested_func.h"
 #include <sys/ptrace.h>
 
 /* Maximum number of DWARF expression stack slots before returning an error.  */
@@ -108,17 +109,16 @@ static bool
 expr_eval (Dwfl_Frame *state, Dwarf_Frame *frame, const Dwarf_Op *ops,
 	   size_t nops, Dwarf_Addr *result, Dwarf_Addr bias)
 {
-  Dwfl_Process *process = state->thread->process;
+  __BLOCK Dwfl_Process *process = state->thread->process;
   if (nops == 0)
     {
       __libdwfl_seterrno (DWFL_E_INVALID_DWARF);
       return false;
     }
-  Dwarf_Addr *stack = NULL;
-  size_t stack_used = 0, stack_allocated = 0;
+  __BLOCK Dwarf_Addr *stack = NULL;
+  __BLOCK size_t stack_used = 0, stack_allocated = 0;
 
-  bool
-  push (Dwarf_Addr val)
+  NESTED_FUNC (bool, push, (Dwarf_Addr), (Dwarf_Addr val))
   {
     if (stack_used >= DWARF_EXPR_STACK_MAX)
       {
@@ -138,10 +138,9 @@ expr_eval (Dwfl_Frame *state, Dwarf_Frame *frame, const Dwarf_Op *ops,
       }
     stack[stack_used++] = val;
     return true;
-  }
+  };
 
-  bool
-  pop (Dwarf_Addr *val)
+  NESTED_FUNC (bool, pop, (Dwarf_Addr *), (Dwarf_Addr *val))
   {
     if (stack_used == 0)
       {
@@ -150,7 +149,7 @@ expr_eval (Dwfl_Frame *state, Dwarf_Frame *frame, const Dwarf_Op *ops,
       }
     *val = stack[--stack_used];
     return true;
-  }
+  };
 
   Dwarf_Addr val1, val2;
   bool is_location = false;
diff --git a/libdwfl/gzip.c b/libdwfl/gzip.c
index b7dde5d..af466e6 100644
--- a/libdwfl/gzip.c
+++ b/libdwfl/gzip.c
@@ -28,6 +28,7 @@
 
 #include "libdwflP.h"
 #include "system.h"
+#include "nested_func.h"
 
 #include <unistd.h>
 
@@ -79,9 +80,9 @@ unzip (int fd, off64_t start_offset,
        void *mapped, size_t mapped_size,
        void **whole, size_t *whole_size)
 {
-  void *buffer = NULL;
-  size_t size = 0;
-  inline bool bigger_buffer (size_t start)
+  __BLOCK void *buffer = NULL;
+  __BLOCK size_t size = 0;
+  INLINE_NESTED_FUNC (bool, bigger_buffer, (size_t), (size_t start))
   {
     size_t more = size ? size * 2 : start;
     char *b = realloc (buffer, more);
@@ -92,17 +93,17 @@ unzip (int fd, off64_t start_offset,
     buffer = b;
     size = more;
     return true;
-  }
-  inline void smaller_buffer (size_t end)
+  };
+  INLINE_NESTED_FUNC (void, smaller_buffer, (size_t), (size_t end))
   {
     buffer = realloc (buffer, end) ?: end == 0 ? NULL : buffer;
     size = end;
-  }
+  };
 
-  void *input_buffer = NULL;
-  off_t input_pos = 0;
+  __BLOCK void *input_buffer = NULL;
+  __BLOCK off_t input_pos = 0;
 
-  inline Dwfl_Error fail (Dwfl_Error failure)
+  INLINE_NESTED_FUNC (Dwfl_Error, fail, (Dwfl_Error), (Dwfl_Error failure))
   {
     if (input_pos == (off_t) mapped_size)
       *whole = input_buffer;
@@ -113,9 +114,9 @@ unzip (int fd, off64_t start_offset,
       }
     free (buffer);
     return failure;
-  }
+  };
 
-  inline Dwfl_Error zlib_fail (int result)
+  INLINE_NESTED_FUNC (Dwfl_Error, zlib_fail, (int), (int result))
   {
     switch (result)
       {
@@ -126,7 +127,7 @@ unzip (int fd, off64_t start_offset,
       default:
 	return fail (DWFL_E_ZLIB);
       }
-  }
+  };
 
   if (mapped == NULL)
     {
@@ -169,8 +170,8 @@ unzip (int fd, off64_t start_offset,
      The stupid zlib interface has nothing to grok the
      gzip file headers except the slow gzFile interface.  */
 
-  z_stream z = { .next_in = mapped, .avail_in = mapped_size };
-  int result = inflateInit (&z);
+  __BLOCK z_stream z = { .next_in = mapped, .avail_in = mapped_size };
+  __BLOCK int result = inflateInit (&z);
   if (result != Z (OK))
     {
       inflateEnd (&z);
@@ -223,8 +224,8 @@ unzip (int fd, off64_t start_offset,
 
   /* Let the decompression library read the file directly.  */
 
-  gzFile zf;
-  Dwfl_Error open_stream (void)
+  __BLOCK gzFile zf;
+  NESTED_FUNC (Dwfl_Error, open_stream, (void), (void))
   {
     int d = dup (fd);
     if (unlikely (d < 0))
@@ -248,7 +249,7 @@ unzip (int fd, off64_t start_offset,
     /* From here on, zlib will close D.  */
 
     return DWFL_E_NOERROR;
-  }
+  };
 
   Dwfl_Error result = open_stream ();
 
diff --git a/libdwfl/link_map.c b/libdwfl/link_map.c
index a756e43..24e0166 100644
--- a/libdwfl/link_map.c
+++ b/libdwfl/link_map.c
@@ -30,6 +30,7 @@
 #include "libdwflP.h"
 #include "../libdw/memory-access.h"
 #include "system.h"
+#include "nested_func.h"
 
 #include <byteswap.h>
 #include <endian.h>
@@ -48,10 +49,10 @@ static bool
 auxv_format_probe (const void *auxv, size_t size,
 		   uint_fast8_t *elfclass, uint_fast8_t *elfdata)
 {
-  const Elf32_auxv_t *a32 = auxv;
-  const Elf64_auxv_t *a64 = auxv;
+  __BLOCK const Elf32_auxv_t *a32 = auxv;
+  __BLOCK const Elf64_auxv_t *a64 = auxv;
 
-  inline bool check64 (size_t i)
+  INLINE_NESTED_FUNC (bool, check64, (size_t), (size_t i))
   {
     /* The AUXV pointer might not even be naturally aligned for 64-bit
        data, because note payloads in a core file are not aligned.  */
@@ -74,9 +75,9 @@ auxv_format_probe (const void *auxv, size_t size,
       }
 
     return false;
-  }
+  };
 
-  inline bool check32 (size_t i)
+  INLINE_NESTED_FUNC (bool, check32, (size_t), (size_t i))
   {
     /* The AUXV pointer might not even be naturally aligned for 32-bit
        data, because note payloads in a core file are not aligned.  */
@@ -99,7 +100,7 @@ auxv_format_probe (const void *auxv, size_t size,
       }
 
     return false;
-  }
+  };
 
   for (size_t i = 0; i < size / sizeof (Elf64_auxv_t); ++i)
     {
@@ -243,20 +244,27 @@ report_r_debug (uint_fast8_t elfclass, uint_fast8_t elfdata,
 		struct r_debug_info *r_debug_info)
 {
   /* Skip r_version, to aligned r_map field.  */
-  GElf_Addr read_vaddr = r_debug_vaddr + addrsize (elfclass);
+  __BLOCK GElf_Addr read_vaddr = r_debug_vaddr + addrsize (elfclass);
 
-  void *buffer = NULL;
-  size_t buffer_available = 0;
-  inline int release_buffer (int result)
+  __BLOCK void *buffer = NULL;
+  __BLOCK size_t buffer_available = 0;
+  INLINE_NESTED_FUNC (int, release_buffer, (int), (int result))
   {
     if (buffer != NULL)
       (void) (*memory_callback) (dwfl, -1, &buffer, &buffer_available, 0, 0,
 				 memory_callback_arg);
     return result;
-  }
+  };
 
+#if __clang__
+  /* Clang Blocks cannot copy an array to a closure. */
+  __BLOCK GElf_Addr *addrs = alloca(4 * sizeof (GElf_Addr));
+#else
+  /* gcc complains about unbounded stack usage from alloca. */
   GElf_Addr addrs[4];
-  inline bool read_addrs (GElf_Addr vaddr, size_t n)
+#endif
+  INLINE_NESTED_FUNC (bool, read_addrs,
+                      (GElf_Addr, size_t), (GElf_Addr vaddr, size_t n))
   {
     size_t nb = n * addrsize (elfclass); /* Address words -> bytes to read.  */
 
@@ -299,7 +307,7 @@ report_r_debug (uint_fast8_t elfclass, uint_fast8_t elfdata,
       }
 
     return false;
-  }
+  };
 
   if (unlikely (read_addrs (read_vaddr, 1)))
     return release_buffer (-1);
@@ -690,17 +698,17 @@ dwfl_link_map_report (Dwfl *dwfl, const void *auxv, size_t auxv_size,
 		      void *memory_callback_arg,
 		      struct r_debug_info *r_debug_info)
 {
-  GElf_Addr r_debug_vaddr = 0;
+  __BLOCK GElf_Addr r_debug_vaddr = 0;
 
-  uint_fast8_t elfclass = ELFCLASSNONE;
-  uint_fast8_t elfdata = ELFDATANONE;
+  __BLOCK uint_fast8_t elfclass = ELFCLASSNONE;
+  __BLOCK uint_fast8_t elfdata = ELFDATANONE;
   if (likely (auxv != NULL)
       && likely (auxv_format_probe (auxv, auxv_size, &elfclass, &elfdata)))
     {
-      GElf_Addr entry = 0;
-      GElf_Addr phdr = 0;
-      GElf_Xword phent = 0;
-      GElf_Xword phnum = 0;
+      __BLOCK GElf_Addr entry = 0;
+      __BLOCK GElf_Addr phdr = 0;
+      __BLOCK GElf_Xword phent = 0;
+      __BLOCK GElf_Xword phnum = 0;
 
 #define READ_AUXV32(ptr)	read_4ubyte_unaligned_noncvt (ptr)
 #define READ_AUXV64(ptr)	read_8ubyte_unaligned_noncvt (ptr)
@@ -746,12 +754,13 @@ dwfl_link_map_report (Dwfl *dwfl, const void *auxv, size_t auxv_size,
 	}
 
       /* If we found the phdr dimensions, search phdrs for PT_DYNAMIC.  */
-      GElf_Addr dyn_vaddr = 0;
-      GElf_Xword dyn_filesz = 0;
-      GElf_Addr dyn_bias = (GElf_Addr) -1;
+      __BLOCK GElf_Addr dyn_vaddr = 0;
+      __BLOCK GElf_Xword dyn_filesz = 0;
+      __BLOCK GElf_Addr dyn_bias = (GElf_Addr) -1;
 
-      inline bool consider_phdr (GElf_Word type,
-				 GElf_Addr vaddr, GElf_Xword filesz)
+      INLINE_NESTED_FUNC (bool, consider_phdr,
+                          (GElf_Word, GElf_Addr, GElf_Xword),
+                          (GElf_Word type, GElf_Addr vaddr, GElf_Xword filesz))
       {
 	switch (type)
 	  {
@@ -773,7 +782,7 @@ dwfl_link_map_report (Dwfl *dwfl, const void *auxv, size_t auxv_size,
 	  }
 
 	return false;
-      }
+      };
 
       if (phdr != 0 && phnum != 0)
 	{
diff --git a/libdwfl/linux-kernel-modules.c b/libdwfl/linux-kernel-modules.c
index 236e2cd..5620bc1 100644
--- a/libdwfl/linux-kernel-modules.c
+++ b/libdwfl/linux-kernel-modules.c
@@ -34,6 +34,7 @@
 #include <config.h>
 
 #include "libdwflP.h"
+#include "nested_func.h"
 #include <inttypes.h>
 #include <errno.h>
 #include <stdio.h>
@@ -444,7 +445,7 @@ INTDEF (dwfl_linux_kernel_report_offline)
 static int
 intuit_kernel_bounds (Dwarf_Addr *start, Dwarf_Addr *end, Dwarf_Addr *notes)
 {
-  FILE *f = fopen (KSYMSFILE, "r");
+  __BLOCK FILE *f = fopen (KSYMSFILE, "r");
   if (f == NULL)
     return errno;
 
@@ -452,13 +453,13 @@ intuit_kernel_bounds (Dwarf_Addr *start, Dwarf_Addr *end, Dwarf_Addr *notes)
 
   *notes = 0;
 
-  char *line = NULL;
-  size_t linesz = 0;
-  size_t n;
-  char *p = NULL;
-  const char *type;
+  __BLOCK char *line = NULL;
+  __BLOCK size_t linesz = 0;
+  __BLOCK size_t n;
+  __BLOCK char *p = NULL;
+  __BLOCK const char *type;
 
-  inline bool read_address (Dwarf_Addr *addr)
+  INLINE_NESTED_FUNC (bool, read_address, (Dwarf_Addr *), (Dwarf_Addr *addr))
   {
     if ((n = getline (&line, &linesz, f)) < 1 || line[n - 2] == ']')
       return false;
@@ -468,7 +469,7 @@ intuit_kernel_bounds (Dwarf_Addr *start, Dwarf_Addr *end, Dwarf_Addr *notes)
     if (type == NULL)
       return false;
     return p != NULL && p != line;
-  }
+  };
 
   int result;
   do
@@ -619,12 +620,12 @@ check_module_notes (Dwfl_Module *mod)
 int
 dwfl_linux_kernel_report_kernel (Dwfl *dwfl)
 {
-  Dwarf_Addr start;
-  Dwarf_Addr end;
-  inline Dwfl_Module *report (void)
+  __BLOCK Dwarf_Addr start;
+  __BLOCK Dwarf_Addr end;
+  INLINE_NESTED_FUNC (Dwfl_Module *, report, (void), (void))
     {
       return INTUSE(dwfl_report_module) (dwfl, KERNEL_MODNAME, start, end);
-    }
+    };
 
   /* This is a bit of a kludge.  If we already reported the kernel,
      don't bother figuring it out again--it never changes.  */
@@ -683,18 +684,18 @@ dwfl_linux_kernel_find_elf (Dwfl_Module *mod,
 
   /* Do "find /lib/modules/`uname -r` -name MODULE_NAME.ko".  */
 
-  char *modulesdir[] = { NULL, NULL };
+  __BLOCK char *modulesdir[] = { NULL, NULL };
   if (asprintf (&modulesdir[0], MODULEDIRFMT, release) < 0)
     return -1;
 
-  FTS *fts = fts_open (modulesdir, FTS_NOSTAT | FTS_LOGICAL, NULL);
+  __BLOCK FTS *fts = fts_open (modulesdir, FTS_NOSTAT | FTS_LOGICAL, NULL);
   if (fts == NULL)
     {
       free (modulesdir[0]);
       return -1;
     }
 
-  size_t namelen = strlen (module_name);
+  __BLOCK size_t namelen = strlen (module_name);
 
   /* This is a kludge.  There is no actual necessary relationship between
      the name of the .ko file installed and the module name the kernel
@@ -707,13 +708,13 @@ dwfl_linux_kernel_find_elf (Dwfl_Module *mod,
      two files when either a '_' or '-' appears in a module name, one using
      only '_' and one only using '-'.  */
 
-  char *alternate_name = malloc (namelen + 1);
+  __BLOCK char *alternate_name = malloc (namelen + 1);
   if (unlikely (alternate_name == NULL))
     {
       free (modulesdir[0]);
       return ENOMEM;
     }
-  inline bool subst_name (char from, char to)
+  INLINE_NESTED_FUNC (bool, subst_name, (char, char), (char from, char to))
     {
       const char *n = memchr (module_name, from, namelen);
       if (n == NULL)
@@ -730,7 +731,7 @@ dwfl_linux_kernel_find_elf (Dwfl_Module *mod,
 	}
       memcpy (a, n, namelen - (n - module_name) + 1);
       return true;
-    }
+    };
   if (!subst_name ('-', '_') && !subst_name ('_', '-'))
     alternate_name[0] = '\0';
 
diff --git a/libdwfl/linux-proc-maps.c b/libdwfl/linux-proc-maps.c
index d085834..f22e0bb 100644
--- a/libdwfl/linux-proc-maps.c
+++ b/libdwfl/linux-proc-maps.c
@@ -41,6 +41,7 @@
 #include <assert.h>
 #include <endian.h>
 #include "system.h"
+#include "nested_func.h"
 
 
 #define PROCMAPSFMT	"/proc/%d/maps"
@@ -178,12 +179,12 @@ grovel_auxv (pid_t pid, Dwfl *dwfl, GElf_Addr *sysinfo_ehdr)
 static int
 proc_maps_report (Dwfl *dwfl, FILE *f, GElf_Addr sysinfo_ehdr, pid_t pid)
 {
-  unsigned int last_dmajor = -1, last_dminor = -1;
-  uint64_t last_ino = -1;
-  char *last_file = NULL;
-  Dwarf_Addr low = 0, high = 0;
+  __BLOCK unsigned int last_dmajor = -1, last_dminor = -1;
+  __BLOCK uint64_t last_ino = -1;
+  __BLOCK char *last_file = NULL;
+  __BLOCK Dwarf_Addr low = 0, high = 0;
 
-  inline bool report (void)
+  INLINE_NESTED_FUNC (bool, report, (void), (void))
     {
       if (last_file != NULL)
 	{
@@ -195,7 +196,7 @@ proc_maps_report (Dwfl *dwfl, FILE *f, GElf_Addr sysinfo_ehdr, pid_t pid)
 	    return true;
 	}
       return false;
-    }
+    };
 
   char *line = NULL;
   size_t linesz;
diff --git a/libdwfl/relocate.c b/libdwfl/relocate.c
index e102e1e..fdbf096 100644
--- a/libdwfl/relocate.c
+++ b/libdwfl/relocate.c
@@ -27,6 +27,7 @@
    not, see <http://www.gnu.org/licenses/>.  */
 
 #include "libdwflP.h"
+#include "nested_func.h"
 
 typedef uint8_t GElf_Byte;
 
@@ -284,9 +285,9 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
 		  Elf_Scn *tscn, bool debugscn, bool partial)
 {
   /* First, fetch the name of the section these relocations apply to.  */
-  GElf_Shdr tshdr_mem;
-  GElf_Shdr *tshdr = gelf_getshdr (tscn, &tshdr_mem);
-  const char *tname = elf_strptr (relocated, shstrndx, tshdr->sh_name);
+  __BLOCK GElf_Shdr tshdr_mem;
+  __BLOCK GElf_Shdr *tshdr = gelf_getshdr (tscn, &tshdr_mem);
+  __BLOCK const char *tname = elf_strptr (relocated, shstrndx, tshdr->sh_name);
   if (tname == NULL)
     return DWFL_E_LIBELF;
 
@@ -300,7 +301,7 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
     return DWFL_E_NOERROR;
 
   /* Fetch the section data that needs the relocations applied.  */
-  Elf_Data *tdata = elf_rawdata (tscn, NULL);
+  __BLOCK Elf_Data *tdata = elf_rawdata (tscn, NULL);
   if (tdata == NULL)
     return DWFL_E_LIBELF;
 
@@ -310,26 +311,26 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
      isn't illegal for ELF section data to overlap the header data,
      but updating the (relocation) data might corrupt the in-memory
      libelf headers causing strange corruptions or errors.  */
-  size_t ehsize = gelf_fsize (relocated, ELF_T_EHDR, 1, EV_CURRENT);
+  __BLOCK size_t ehsize = gelf_fsize (relocated, ELF_T_EHDR, 1, EV_CURRENT);
   if (unlikely (shdr->sh_offset < ehsize
 		|| tshdr->sh_offset < ehsize))
     return DWFL_E_BADELF;
 
-  GElf_Off shdrs_start = ehdr->e_shoff;
-  size_t shnums;
+  __BLOCK GElf_Off shdrs_start = ehdr->e_shoff;
+  __BLOCK size_t shnums;
   if (elf_getshdrnum (relocated, &shnums) < 0)
     return DWFL_E_LIBELF;
   /* Overflows will have been checked by elf_getshdrnum/get|rawdata.  */
-  size_t shentsize = gelf_fsize (relocated, ELF_T_SHDR, 1, EV_CURRENT);
-  GElf_Off shdrs_end = shdrs_start + shnums * shentsize;
+  __BLOCK size_t shentsize = gelf_fsize (relocated, ELF_T_SHDR, 1, EV_CURRENT);
+  __BLOCK GElf_Off shdrs_end = shdrs_start + shnums * shentsize;
   if (unlikely ((shdrs_start < shdr->sh_offset + shdr->sh_size
 		 && shdr->sh_offset < shdrs_end)
 		|| (shdrs_start < tshdr->sh_offset + tshdr->sh_size
 		    && tshdr->sh_offset < shdrs_end)))
     return DWFL_E_BADELF;
 
-  GElf_Off phdrs_start = ehdr->e_phoff;
-  size_t phnums;
+  __BLOCK GElf_Off phdrs_start = ehdr->e_phoff;
+  __BLOCK size_t phnums;
   if (elf_getphdrnum (relocated, &phnums) < 0)
     return DWFL_E_LIBELF;
   if (phdrs_start != 0 && phnums != 0)
@@ -345,8 +346,10 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
     }
 
   /* Apply one relocation.  Returns true for any invalid data.  */
-  Dwfl_Error relocate (GElf_Addr offset, const GElf_Sxword *addend,
-		       int rtype, int symndx)
+  NESTED_FUNC (Dwfl_Error, relocate,
+               (GElf_Addr, const GElf_Sxword *, int, int),
+               (GElf_Addr offset, const GElf_Sxword *addend,
+                int rtype, int symndx))
   {
     /* First see if this is a reloc we can handle.
        If we are skipping it, don't bother resolving the symbol.  */
@@ -482,16 +485,16 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
 
     /* We have applied this relocation!  */
     return DWFL_E_NOERROR;
-  }
+  };
 
   /* Fetch the relocation section and apply each reloc in it.  */
-  Elf_Data *reldata = elf_getdata (scn, NULL);
+  __BLOCK Elf_Data *reldata = elf_getdata (scn, NULL);
   if (reldata == NULL)
     return DWFL_E_LIBELF;
 
-  Dwfl_Error result = DWFL_E_NOERROR;
-  bool first_badreltype = true;
-  inline void check_badreltype (void)
+  __BLOCK Dwfl_Error result = DWFL_E_NOERROR;
+  __BLOCK bool first_badreltype = true;
+  INLINE_NESTED_FUNC (void, check_badreltype, (void), (void))
   {
     if (first_badreltype)
       {
@@ -501,7 +504,7 @@ relocate_section (Dwfl_Module *mod, Elf *relocated, const GElf_Ehdr *ehdr,
 	     any libebl_CPU.so library.  Diagnose that clearly.  */
 	  result = DWFL_E_UNKNOWN_MACHINE;
       }
-  }
+  };
 
   size_t sh_entsize
     = gelf_fsize (relocated, shdr->sh_type == SHT_REL ? ELF_T_REL : ELF_T_RELA,
diff --git a/libelf/ChangeLog b/libelf/ChangeLog
index a9685ba..f55712a 100644
--- a/libelf/ChangeLog
+++ b/libelf/ChangeLog
@@ -1,3 +1,10 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* elf32_updatefile.c (__elfw2(LIBELFBITS,updatemmap)): Use *NESTED_FUNC
+	macro for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+	* elf_begin.c (elf_begin): Likewise.
+
 2015-09-08  Chih-Hung Hsieh <chh@google.com>
 
 	* elf_getarsym.c (elf_getarsym): Do not use
diff --git a/libelf/elf32_updatefile.c b/libelf/elf32_updatefile.c
index 832f852..e0f43c6 100644
--- a/libelf/elf32_updatefile.c
+++ b/libelf/elf32_updatefile.c
@@ -43,6 +43,7 @@
 
 #include <system.h>
 #include "libelfP.h"
+#include "nested_func.h"
 
 
 #ifndef LIBELFBITS
@@ -303,7 +304,7 @@ __elfw2(LIBELFBITS,updatemmap) (Elf *elf, int change_bo, size_t shnum)
 	  Elf_Data_List *dl = &scn->data_list;
 	  bool scn_changed = false;
 
-	  void fill_mmap (size_t offset)
+	  NESTED_FUNC (void, fill_mmap, (size_t), (size_t offset))
 	  {
 	    size_t written = 0;
 
@@ -322,7 +323,7 @@ __elfw2(LIBELFBITS,updatemmap) (Elf *elf, int change_bo, size_t shnum)
 		memset (fill_start, __libelf_fill_byte,
 			scn_start + offset - fill_start);
 	      }
-	  }
+	  };
 
 	  if (scn->data_list_rear != NULL)
 	    do
diff --git a/libelf/elf_begin.c b/libelf/elf_begin.c
index f002ebf..6878298 100644
--- a/libelf/elf_begin.c
+++ b/libelf/elf_begin.c
@@ -46,6 +46,7 @@
 #include <system.h>
 #include "libelfP.h"
 #include "common.h"
+#include "nested_func.h"
 
 
 /* Create descriptor for archive in memory.  */
@@ -1067,7 +1068,7 @@ elf_begin (fildes, cmd, ref)
       return NULL;
     }
 
-  Elf *lock_dup_elf ()
+  NESTED_FUNC (Elf *, lock_dup_elf, (void), (void))
   {
     /* We need wrlock to dup an archive.  */
     if (ref->kind == ELF_K_AR)
@@ -1078,7 +1079,7 @@ elf_begin (fildes, cmd, ref)
 
     /* Duplicate the descriptor.  */
     return dup_elf (fildes, cmd, ref);
-  }
+  };
 
   switch (cmd)
     {
diff --git a/src/ChangeLog b/src/ChangeLog
index 7848064..3965281 100644
--- a/src/ChangeLog
+++ b/src/ChangeLog
@@ -1,3 +1,24 @@
+2015-09-10  Chih-Hung Hsieh  <chh@google.com>
+
+	* addr2line.c (handle_address): Use *NESTED_FUNC
+	macro for nested functions and __BLOCK macro for variables used inside
+	nested functions.
+	* ar.c (do_oper_extract): Likewise.
+	* arlib-argp.c (parse_opt): Likewise.
+	* elflint.c (check_attributes): Likewise.
+	* ld.c (determine_output_format): Likewise.
+	* readelf.c (parse_opt): Likewise.
+	(print_attributes): Likewise.
+	(print_cfa_program): Likewise.
+	(print_debug_line_section): Likewise.
+	(handle_core_registers): Likewise.
+	* strip.c (handle_elf): Likewise.
+	* unstrip.c (adjust_relocs): Likewise.
+	(find_alloc_sections_prelink): Likewise.
+	(copy_elided_sections): Likewise.
+	(handle_explicit_files): Likewise.
+	(match_module): Likewise.
+
 2015-09-10  Chih-Hung Hsieh <chh@google.com>
 
 	* readelf.c (print_cfa_program): Do not use
diff --git a/src/addr2line.c b/src/addr2line.c
index 0ce854f..4932189 100644
--- a/src/addr2line.c
+++ b/src/addr2line.c
@@ -39,6 +39,7 @@
 
 #include <system.h>
 
+#include "nested_func.h"
 
 /* Name and version of program.  */
 static void print_version (FILE *stream, struct argp_state *state);
@@ -705,20 +706,26 @@ handle_address (const char *string, Dwfl *dwfl)
 	  Dwarf_Line *info = dwfl_dwarf_line (line, &bias);
 	  assert (info != NULL);
 
-	  inline void show (int (*get) (Dwarf_Line *, bool *),
-			    const char *note)
+	  INLINE_NESTED_FUNC (void, show,
+	                      (int (*) (Dwarf_Line *, bool *),
+	                       const char *),
+	                      (int (*get) (Dwarf_Line *, bool *),
+	                       const char *note))
 	  {
 	    bool flag;
 	    if ((*get) (info, &flag) == 0 && flag)
 	      fputs (note, stdout);
-	  }
-	  inline void show_int (int (*get) (Dwarf_Line *, unsigned int *),
-				const char *name)
+	  };
+	  INLINE_NESTED_FUNC (void, show_int,
+	                      (int (*) (Dwarf_Line *, unsigned int *),
+	                       const char *),
+	                      (int (*get) (Dwarf_Line *, unsigned int *),
+	                       const char *name))
 	  {
 	    unsigned int val;
 	    if ((*get) (info, &val) == 0 && val != 0)
 	      printf (" (%s %u)", name, val);
-	  }
+	  };
 
 	  show (&dwarf_linebeginstatement, " (is_stmt)");
 	  show (&dwarf_lineblock, " (basic_block)");
diff --git a/src/ar.c b/src/ar.c
index 1320d07..f4f2668 100644
--- a/src/ar.c
+++ b/src/ar.c
@@ -43,6 +43,7 @@
 #include <system.h>
 
 #include "arlib.h"
+#include "nested_func.h"
 
 
 /* Name and version of program.  */
@@ -459,8 +460,8 @@ do_oper_extract (int oper, const char *arfname, char **argv, int argc,
   bool found[argc];
   memset (found, '\0', sizeof (found));
 
-  size_t name_max = 0;
-  inline bool should_truncate_fname (void)
+  __BLOCK size_t name_max = 0;
+  INLINE_NESTED_FUNC (bool, should_truncate_fname, (void), (void))
   {
     if (errno == ENAMETOOLONG && allow_truncate_fname)
       {
@@ -473,7 +474,7 @@ do_oper_extract (int oper, const char *arfname, char **argv, int argc,
 	return name_max != 0;
       }
     return false;
-  }
+  };
 
   off_t index_off = -1;
   size_t index_size = 0;
diff --git a/src/arlib-argp.c b/src/arlib-argp.c
index 1bdd8d0..1fcb375 100644
--- a/src/arlib-argp.c
+++ b/src/arlib-argp.c
@@ -23,6 +23,7 @@
 #include <libintl.h>
 
 #include "arlib.h"
+#include "nested_func.h"
 
 bool arlib_deterministic_output = DEFAULT_AR_DETERMINISTIC;
 
@@ -59,13 +60,13 @@ parse_opt (int key, char *arg __attribute__ ((unused)),
 static char *
 help_filter (int key, const char *text, void *input __attribute__ ((unused)))
 {
-  inline char *text_for_default (void)
+  INLINE_NESTED_FUNC (char *, text_for_default, (void), (void))
   {
     char *new_text;
     if (unlikely (asprintf (&new_text, gettext ("%s (default)"), text) < 0))
       return (char *) text;
     return new_text;
-  }
+  };
 
   switch (key)
     {
